/*
                             Buffer Blitting

	    (Came from XShipwars client code, maybe out of date)

 */

#ifndef BLITTING_H
#define BLITTING_H


#include <math.h>

#include "../include/graphics.h"
#include "../include/widget.h"		/* Need to know about WColorStruct. */


/*
 *	Visibility coefficents:
 *
 *	For cloaking affect in BlitBufNormal().
 */
#define VIS_FULL        0.95
#define VIS_THRESH      0.5
#define VIS_INVIS       0.05



/* In blitstd.c */
extern void BlitBufNormal(
	unsigned int d,
        char *tar_buf,
        char *src_buf,
        int tar_x,
        int tar_y,
        unsigned int tar_width,
        unsigned int tar_height,
        int src_x,
        int src_y,
        unsigned int src_width,
        unsigned int src_height,
        unsigned int src_copy_width,
        unsigned int src_copy_height,
        double zoom,			/* 0.1 to 1.0 supported. */
	double vis			/* 0.0 to 1.0 supported. */
);

extern void BlitBufAbsolute(
        unsigned int d,
        char *tar_buf,
        char *src_buf,
        int tar_x,
        int tar_y,
        unsigned int tar_width,
        unsigned int tar_height,
        int src_x,
        int src_y,
        unsigned int src_width,
        unsigned int src_height,
        unsigned int src_copy_width,
        unsigned int src_copy_height,
        double zoom                     /* 0.1 to 1.0 supported. */
);

extern void BlitBufAdditive(
        unsigned int d,
        char *tar_buf,
        char *src_buf,
        int tar_x,
        int tar_y,
        unsigned int tar_width,
        unsigned int tar_height,
        int src_x,
        int src_y,
        unsigned int src_width,
        unsigned int src_height,
        unsigned int src_copy_width,
        unsigned int src_copy_height,
        double zoom                     /* 0.1 to 1.0 supported. */
);

extern void BlitBufSolid(
	unsigned int d,
	char *tar_buf,
	unsigned int tar_width,
	unsigned int tar_height,
	WColorStruct color
);



/* In blitcircle.c */
extern void BlitBufCircle(
        unsigned int d,
        char *tar_buf,
        int tar_x,
        int tar_y,
        unsigned int tar_width,
        unsigned int tar_height,
        double thickness,               /* In pixels. */
        double radius,                  /* In pixels. */
        WColorStruct fg_color
);






#endif /* BLITTING_H */
